package com.fossgalaxy.games.tbs.ai.rules;

import com.fossgalaxy.games.tbs.GameState;
import com.fossgalaxy.games.tbs.actions.AbstractAction;
import com.fossgalaxy.games.tbs.actions.MoveAction;
import com.fossgalaxy.games.tbs.entity.Entity;
import com.fossgalaxy.games.tbs.order.Order;
import com.fossgalaxy.games.tbs.ui.GameAction;
import org.codetome.hexameter.core.api.CubeCoordinate;

import java.util.List;

public class MovementRule extends FirstLegalRule {

    public MovementRule() {
        super(AbstractAction.CAT_MOVE);
    }

    @Override
    public boolean isForEntity(GameState state, Entity entity) {
        return entity.getProperty(MoveAction.MOVEMENT_PROP) >= 1;
    }

    @Override
    public Order generateOrder(GameState state, Entity entity) {

        CubeCoordinate coordinate = chooseTarget(entity, state);
        if (coordinate == null){
            return null;
        }

        List<GameAction> actions = entity.getType().getAvailableActions();
        for (GameAction action : actions) {

            if (!category.equals(action.getCategory())) {
                continue;
            }


            return super.moveTo(state, coordinate, entity);
        }

        System.out.println("no movement orders :(");
        return null;
    }
}
